/*
 *  Copyright 2016 Alexey Andreev.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.teavm.backend.wasm.model;

import java.util.Objects;

public class WasmLocal {
    WasmFunction function;
    int index;
    private String name;
    private WasmType type;

    public WasmLocal(WasmType type, String name) {
        Objects.requireNonNull(type);
        this.type = type;
        this.name = name;
    }

    public WasmLocal(WasmType type) {
        this(type, null);
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public WasmType getType() {
        return type;
    }

    public void setType(WasmType type) {
        Objects.requireNonNull(type);
        this.type = type;
    }

    public WasmFunction getFunction() {
        return function;
    }

    public int getIndex() {
        return index;
    }
}
