/*
 *  Copyright 2017 Alexey Andreev.
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.teavm.parsing.resource;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;

public class DirectoryResourceReader implements ResourceReader {
    private File baseDir;

    public DirectoryResourceReader(File baseDir) {
        this.baseDir = baseDir;
    }

    @Override
    public boolean hasResource(String name) {
        return new File(baseDir, name).isFile();
    }

    @Override
    public InputStream openResource(String name) throws IOException {
        return new FileInputStream(new File(baseDir, name));
    }
}
